/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafListUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafListUI extends BasicListUI
{
  public static ComponentUI createUI(JComponent c)
  {
    /*
    ListModel lm=((JList)c).getModel();
    if(lm!=null)
    {
      System.err.println("DIR-MODEL="+(lm instanceof BasicDirectoryModel));
      if(  !(lm instanceof BasicDirectoryModel)
         ||!lm.getClass().getName().equals
	    ("javax.swing.plaf.metal.MetalFileChooserUI$DirectoryComboBoxModel"))
	{
	  System.err.println("!!!!! FAIL UI");
	  return BasicListUI.createUI(c);
	  //ComponentUI.createUI(c);
	}
    }
    */
    return new SlafListUI();
  }
 
  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);
  }

  /*
  Method javax.swing.plaf.ComponentUI createUI(javax.swing.JComponent)
   0 ldc #3 <String "alloy.isSandbox">
   2 ldc #4 <String "true">
   4 invokestatic #5 <Method boolean b(java.lang.String, java.lang.String)>
   7 ifeq 49
  10 aload_0
  11 checkcast #6 <Class javax.swing.JList>
  14 invokevirtual #7 <Method javax.swing.ListModel getModel()>
  17 astore_1
  18 aload_1
  19 ifnull 49
  22 aload_1
  23 instanceof #8 <Class javax.swing.plaf.basic.BasicDirectoryModel>
  26 ifne 44
  29 aload_1
  30 invokevirtual #9 <Method java.lang.Class getClass()>
  33 invokevirtual #10 <Method java.lang.String getName()>
  36 ldc #11 <String "javax.swing.plaf.metal.MetalFileChooserUI$DirectoryComboBoxModel">
  38 invokevirtual #12 <Method boolean equals(java.lang.Object)>
  41 ifeq 49
  44 aload_0
  45 invokestatic #13 <Method javax.swing.plaf.ComponentUI createUI(javax.swing.JComponent)>
  48 areturn
  49 new #14 <Class com.incors.plaf.alloy.AlloyListUI>
  52 dup
  53 invokespecial #15 <Method com.incors.plaf.alloy.AlloyListUI()>
  56 areturn

  Method void installListeners()
   0 aload_0
   1 invokespecial #16 <Method void installListeners()>
   4 ldc #3 <String "alloy.isSandbox">
   6 ldc #4 <String "true">
   8 invokestatic #5 <Method boolean b(java.lang.String, java.lang.String)>
  11 ifeq 37
  14 aload_0
  15 new #17 <Class com.incors.plaf.alloy.bf>
  18 dup
  19 aload_0
  20 invokespecial #18 <Method com.incors.plaf.alloy.bf(com.incors.plaf.alloy.AlloyListUI)>
  23 putfield #19 <Field com.incors.plaf.alloy.bf a>
  26 aload_0
  27 getfield #20 <Field null>
  30 aload_0
  31 getfield #19 <Field com.incors.plaf.alloy.bf a>
  34 invokevirtual #21 <Method null>
  37 return
  */

  protected void paintBackground(Graphics g, JComponent l)
  {
    if(l.isOpaque())
    {
      Rectangle r=SlafUtils.getFullRect  (l);
      Color     c=SlafUtils.getBackground(l);
      SlafUtils.paintBackground(g,r,l,c);
    }
  }
  
  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,c);
    paint(g,c);
    //SlafUtils.paintOver(g,(AbstractButton)c);
  }
}
