/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/Slaf.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import java.lang.reflect.*; 
import javax.swing.*; 

public class Slaf
{
  public static void main(String[] args)
  {
    /*
    String jv=System.getProperty("java.version");
    if(jv.compareTo("1.1.2")<0)
    {
      System.err.println("JVM >1.1.2 needed for Swing");
      System.exit(-1);
    }
    */

    if(  (args.length==1)
       ||(args.length==3)&&(args[0].equals("--theme")))
    {
    }
    else
    {
      System.err.println
	("Syntax: java com.memoire.slaf.Slaf [--theme <theme_name>]"+
	 " <your_main_class>");
      System.exit(-2);
    }

    int begin_args=0;
    
    try
    {
      if((args.length>2)&&(args[0].equals("--theme")))
      {
	SlafLookAndFeel.setCurrentTheme(args[1]);
	begin_args=2;
      }
      UIManager.setLookAndFeel
	("com.memoire.slaf.SlafLookAndFeel");
    }
    catch(Exception ex)
    {
      System.err.println("Error: can not load ("+ex.getMessage()+")");
      // ex.printStackTrace();
      System.exit(-3);
    }

    try
    {
      Class    c =Class.forName(args[begin_args]);
      Class[]  cp=new Class[] { String[].class };
      Method   m =c.getMethod("main",cp);
      String[] a =new String[args.length-1-begin_args];
      for(int i=1+begin_args;i<args.length;i++) a[i-1-begin_args]=args[i];
      Object[] op=new Object[] { a };
      m.invoke(null,op);
    }
    catch(InvocationTargetException ex)
    {
      System.err.println("Error: can not invoke "+args[begin_args]+
			 ".main(...)");
      // SlafUtils.trace("JAVA: "+args[begin_args]);
      SlafUtils.trace(""+ex.getTargetException());
      ex.getTargetException().printStackTrace();
      System.exit(-4);
    }
    catch(Exception ex)
    {
      System.err.println("Error: can not launch "+args[begin_args]);
      // SlafUtils.trace("JAVA: "+args[begin_args]);
      SlafUtils.trace(""+ex);
      ex.printStackTrace();
      System.exit(-5);
    }
  }
}
