/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafInternalFrameTitleButton.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class SlafInternalFrameTitleButton extends SlafSpecialButton
{
  public SlafInternalFrameTitleButton()//Icon _icon)
  {
    super();
    //setIcon(_icon);
    setFocusPainted(false);
  }

  public String getUIClassID()
  {
    return "InternalFrameTitleButtonUI";
  }

  public Dimension getMinimumSize()
  {
    return getPreferredSize();
  }
  
  public Dimension getMaximumSize()
  {
    return new Dimension(Short.MAX_VALUE,Short.MAX_VALUE);
  }

  public boolean isFocusTraversable() { return false; }
  public void    requestFocus      () { }
}
