/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafPasswordFieldUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafPasswordFieldUI extends SlafTextFieldUI
{
  public static ComponentUI createUI(JComponent c)
  {
    return new SlafPasswordFieldUI();
  }

  protected String getPropertyPrefix()
  {
    return "PasswordField";
  }

  public View create(Element _e)
  {
    return new PasswordView(_e);
  }
}





